<?php

if (!function_exists('qp_encoding')) {
	function qp_encoding($Message) {
		$Message = fixEncoding($Message);
		/* Build (most polpular) Extended ASCII Char/Hex MAP (characters >127 & <255) */
		for ($i=0; $i<127; $i++) {
			$CharList[$i] = "/".chr($i+128)."/";
			$HexList[$i] = "=".strtoupper(bin2hex(chr($i+128)));
		}
	
		/* Encode equal sign & 8-bit characters as equal signs followed by their hexadecimal values */
		$Message = str_replace("=", "=3D", $Message);
		$Message = preg_replace($CharList, $HexList, $Message);
	
		/* Lines longer than 76 characters (size limit for quoted-printable Content-Transfer-Encoding)
			will be cut after character 75 and an equals sign is appended to these lines. */
		$MessageLines = split("\n", $Message);
		$Message_qp = "";
		while(list(, $Line) = each($MessageLines)) {
			if (strlen($Line) > 75) {
				$Pointer = 0;       
				while ($Pointer <= strlen($Line)) {
					$Offset = 0;
					if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+73), 3))) $Offset=-2;
					if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+74), 3))) $Offset=-1;
					$Message_qp.= substr($Line, $Pointer, (75+$Offset))."=\n";
					if ((strlen($Line) - ($Pointer+75)) <= 75) {               
						$Message_qp.= substr($Line, ($Pointer+75+$Offset))."\n";
						break 1;
					}
					$Pointer+= 75+$Offset;
				}
			} else {
				$Message_qp.= $Line."\n";
			}
		}       
		return $Message_qp;
	}
}

if (!function_exists('fixEncoding')) {
// Fixes the encoding to uf8
	function fixEncoding($in_str)
	{
		$cur_encoding = mb_detect_encoding($in_str) ;
		if($cur_encoding == "UTF-8" && mb_check_encoding($in_str,"UTF-8"))
			return $in_str;
		else
			return utf8_encode($in_str);
	} // fixEncoding 
}

if (isset($_POST['contact_submit'])) {
	$tpl->add('empty.tpl', __LINE__, __FILE__);
	$error = '';
	if (empty($_POST['contact_name'])) $error .= $lang['contact_no_name'];
	if (empty($_POST['contact_mail'])) {
		$error .= $lang['contact_no_mail'];
	} else {
		if (!checkmail($_POST['contact_mail'])) {
			$error .= $lang['contact_invalid_mail'];
		}
	}
	if (empty($_POST['contact_subject'])) $error .= $lang['contact_no_subject'];
	if (empty($_POST['contact_content'])) $error .= $lang['contact_no_content'];
	
	if ($error == '') {
		mb_internal_encoding('UTF-8');
		$headers = 'Content-Type: text/plain; charset="UTF-8"' . "\r\n";
		$headers .= 'Content-Transfer-Encoding: quoted-printable' . "\r\n";
		$headers .= 'From: ' . mb_encode_mimeheader($_POST['contact_name'], 'UTF-8', 'Q') . ' <' . $_POST['contact_mail'] . '>';
		$_POST['contact_content'] = wordwrap($_POST['contact_content'], 70);
		mail($config['contact_mail'], '=?UTF-8?Q?' . qp_encoding($_POST['contact_subject']) . '?=', qp_encoding($_POST['contact_content']), $headers);
		$tpl->fillin('S_CONTENT', $lang['contact_send'] . '<a href="' . url() . '">' .$lang['continue'] . '</a>');
	} else {
		$tpl->fillin('S_CONTENT', $lang['contact_error'] . $error . $lang['back']);
	}
} else {
	$tpl->add('contact.tpl', __LINE__, __FILE__, './plugins/contact/templates');
	$tpl->fillin_array(array(
		'S_CONTACT_TITLE' => $lang['contact_title'],
		'S_CONTACT_FORM_NAME' => $lang['name'] . ':',
		'I_CONTACT_FORM_NAME' => '<input type="text" name="contact_name" />',
		'S_CONTACT_FORM_SUBJECT' => $lang['contact_subject'] . ':',
		'I_CONTACT_FORM_SUBJECT' => '<input type="text" name="contact_subject" />',
		'S_CONTACT_FORM_MAIL' => $lang['mail'] . ':',
		'I_CONTACT_FORM_MAIL' => '<input type="text" name="contact_mail" />',
		'S_CONTACT_FORM_CONTENT' => $lang['contact_content'],
		'I_CONTACT_FORM_CONTENT' => '<textarea name="contact_content" cols="60" rows="15"></textarea>',
		'I_CONTACT_FORM_SUBMIT' => '<input type="submit" name="contact_submit" value="' . $lang['send'] . '" class="submit" />',
		'L_CONTACT_ACTION' => url(array('site' => 'contact')),
	));
}

?>
